// FIBONACHI5.cpp:      .
//

#include "stdafx.h"

#include<fstream>
#include<vector>
#include<string>
using namespace std;
#define base (long long)1e+9
typedef vector<long long> mas;
mas a,b;
int n;
ifstream f1("BRICK.DAT");
FILE *f2=fopen("BRICK.SOL","w");
int sum(mas &a,mas &b)
{
	long long c=0;
	for(int i=0;i<max(a.size(),b.size()) || c;i++)
	{
		if(i==a.size()) a.push_back(0);
		a[i]+=c+(i<b.size()?b[i]:0);
		c=a[i]>=base;
		if(c) a[i]-=base;
	}
	return 0;
}
int mult(mas &a,mas &b,mas &c)
{
	c.resize(a.size()+b.size());
	for(int i=0;i<a.size();i++)
		for(int j=0,x=0;j<b.size() || x;j++)
		{
			long long cr=c[i+j]+a[i]*(j<b.size()?b[j]:0)+x;
			c[i+j]=cr%base;
			x=cr/base;
		}
	while(c.size()>1 && !c.back()) c.pop_back();
	return 0;
}
int write(mas &a)
{
	fprintf(f2,"%d",a.empty()?0:a.back());
	for(int i=(int)a.size()-2;i>=0;i--)
		fprintf(f2,"%09d",a[i]);
	fprintf(f2,"\n");
	return 0;
}
void fib(int n) 
{
	mas a11,a12,a21,a22,r11,r12,q11,q12,q21,q22,q;
	a11.push_back(1);
	a12.push_back(1);
	a21.push_back(1);
	a22.push_back(0);
	r11.push_back(1);
	r12.push_back(0);
	while(n)
	{
		if(n&1)
		{
			q11.clear();
			q12.clear();
			q.clear();
			mult(r11,a11,q11);   
			mult(r12,a21,q);     
			sum(q11,q);
			q.clear();
			mult(r11,a12,q12);
			mult(r12,a22,q);
			sum(q12,q);
			r11=q11;
			r12=q12;
			if(n==1) break;
		}
		q.clear();
		q11.clear();
		q12.clear();
		q21.clear();
		q22.clear();
        mult(a11,a11,q11);
		mult(a12,a21,q);
		sum(q11,q);
		q.clear();
		mult(a11,a12,q12);
		mult(a12,a22,q);
		sum(q12,q);
		q.clear();
		mult(a21,a11,q21);
		mult(a22,a21,q);
		sum(q21,q);
		q.clear();
		mult(a21,a12,q22);
		mult(a22,a22,q);
		sum(q22,q);		
		a11=q11;
        a12=q12;
        a21=q21;
        a22=q22; 
        n>>=1;
	}
	write(r12);
}
int main()
{
	f1>>n;
	n++;
	fib(n);
}